package entities;

import java.lang.reflect.Constructor;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.List;
import java.util.logging.ConsoleHandler;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.persistence.Entity;
import javax.persistence.ManyToOne;
import javax.persistence.TypedQuery;

import services.Factory;


import definitions.Findable;
import definitions.Inferable;
import definitions.Language;

@Entity
public class Disjunction extends Statement implements Inferable, Findable{
	
	private static final transient Logger LOG=Logger.getLogger(Disjunction.class.getName());
	static{
		
			LOG.setLevel(Level.ALL);
			
		
	}
	
	public Disjunction() {
		super();
		// TODO Auto-generated constructor stub
	}





	





	private Statement disjunct1;
	
	private Statement disjunct2;

	
		
	

	@Override
	String toString(Language lang) {
		
		String sentance=null;
		
			switch(lang){
			
			case English: sentance="["+disjunct1.toString(lang)+"] or ["+disjunct2.toString(lang)+"]";
			break;
			
			}
			return sentance;
			
			}





	public List<Statement> infer(Factory factory) {
		
		List<Statement>inferences=new LinkedList<Statement>();
		
		//Modus Telendo Ponenz
		Statement impl=(Statement) factory.create(Implication.class,disjunct1.getNegation(),disjunct2);
		
		inferences.add(impl);
		
		return inferences;
		
		
	}
	@ManyToOne
	public Statement getDisjunct2() {
		return disjunct2;
	}





	public Disjunction(Statement disjunct1, Statement disjunct2) {
		super();
		this.disjunct1 = disjunct1;
		this.disjunct2 = disjunct2;
	}





	public void setDisjunct2(Statement disjunct2) {
		this.disjunct2 = disjunct2;
	}





	@ManyToOne
	public Statement getDisjunct1() {
		return disjunct1;
	}





	public void setDisjunct1(Statement disjunct1) {
		this.disjunct1 = disjunct1;
	}





	public Constructor getConstructorForFactory() {
				
				Constructor con=null;
				try {
					con=Disjunction.class.getConstructor(Statement.class, Statement.class);
				} catch (NoSuchMethodException | SecurityException e) {
					
					
					LOG.severe("Conjunction could not supply constructor for factory!");
				}
				return con;
			}





	@Override
	public String getFindingQLString() {
		// TODO Auto-generated method stub
		return "select d from Disjunction d where d.disjunct1.id=?0 and d.disjunct2.id=?1";
	}





	@Override
	public TypedQuery<LogicalObject> prepareQuery(TypedQuery<LogicalObject> query, Object...args) {
		
		Statement disjunct1=(Statement) args[0];
		Statement disjunct2=(Statement) args[1];
		
		
		query.setParameter(0, disjunct1.getId());
		query.setParameter(1, disjunct2.getId());
		
		return query;
		
	}




	
		
	
	} 
	
		
	
	
