package entities;

import java.lang.reflect.Constructor;
import java.util.Set;
import java.util.logging.ConsoleHandler;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.ManyToOne;
import javax.persistence.TypedQuery;

import definitions.ActiveStatement;
import definitions.Findable;
import definitions.Language;

@Entity
public class FollowStatement extends Statement implements Findable,ActiveStatement{
	
	private static transient final Logger LOG=Logger.getLogger(FollowStatement.class.getName());
	static{
		
			LOG.setLevel(Level.ALL);
			ConsoleHandler console=new ConsoleHandler();
			console.setLevel(Level.ALL);
	}
	
	
	Subject idol;

	@ManyToOne
	@Column
	public Subject getIdol() {
		return this.idol;
	}
	public FollowStatement(){
		super();
	}

	public FollowStatement(Subject idol) {
		super();
		this.idol = idol;
	}

	public void setIdol(Subject idol) {
		this.idol = idol;
	}

	@Override
	String toString(Language lang) {
		
		String sentence=null;
		
		switch (lang){
		
				case English: sentence="Follow "+this.idol.toString(Language.English);
				break;
		}
		// TODO Auto-generated method stub
		return sentence;
	}

	
	public Constructor getConstructorForFactory() {
		
		Constructor con =null;
		
		try {
			
			con=FollowStatement.class.getConstructor(Subject.class);
			
		} catch (NoSuchMethodException | SecurityException e) {
			
			LOG.severe("FollowStatement could not supply constructor for factory because "+e.getMessage());
		}
		return con;
	}

	@Override
	public void doAnActionOnANewBeliever(Subject believer) {
		
		
		Set<Subject> followers=idol.getFollowers();
		
		followers.add(believer);
		
		// TODO Auto-generated method stub
		
	}

	@Override
	public void doAnActionOnAnExBeliever(Subject believer) {
		
		Set<Subject> followers=idol.getFollowers();
		
		followers.remove(believer);

		
		
		// TODO Auto-generated method stub
		
	}

	@Override
	public String getFindingQLString() {
		// TODO Auto-generated method stub
		return "select f from FollowStatement f where f.idol.id=?0";
	}

	@Override
	public TypedQuery<LogicalObject> prepareQuery(TypedQuery<LogicalObject> query, Object[] args) {
		// TODO Auto-generated method stub
		Subject idol=(Subject) args[0];
		
		long idolID=idol.getId();
				
				
				return query.setParameter(0,idolID);
				
				
		
		
	}

}
