package entities;

import java.util.Date;

import javax.persistence.Basic;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.MappedSuperclass;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import definitions.FactoryCreatable;
import definitions.Language;


@MappedSuperclass
//@EntityListeners({LogicalObjectLifeCycleLogWriter.class})
public abstract class LogicalObject implements FactoryCreatable{
	
	public LogicalObject(){
		
	}
	
	private long id;
	
	private	Date creatingTime;

	
	/**
	 * 
	 */

	@Id
	@GeneratedValue
	@Basic
	public long getId() {
		return id;
	}

	public void setId(long id) {
		this.id =id;
	}
	
	@Temporal(value=TemporalType.TIMESTAMP)
	public Date getCreatingTime() {
		return creatingTime;
	}




	public void setCreatingTime(Date creatingTime) {
		this.creatingTime = creatingTime;
	}
	
	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + (int) (id ^ (id >>> 32));
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		LogicalObject other = (LogicalObject) obj;
		if (id != other.id)
			return false;
		return true;
	}

	abstract String toString(Language lang);
	
	public String toString(){
				
		return this.toString(Language.English);
		
	}
		
		
	
	
}
