package entities;

import java.lang.reflect.Constructor;
import java.util.logging.ConsoleHandler;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.persistence.Entity;
import javax.persistence.Table;


import definitions.FactoryCreatable;
import definitions.Language;
@Entity
@Table
public class Negation extends Statement implements FactoryCreatable{
	
	private static transient final Logger LOG=Logger.getLogger(Negation.class.getName());
	static{
		
			LOG.setLevel(Level.ALL);
			ConsoleHandler console=new ConsoleHandler();
			console.setLevel(Level.ALL);
			
	}
	public Negation(){
		
	}
	
	public Negation(Statement statement){
		
		this.setNegation(statement);
	}
	
	
	

	@Override
	String toString(Language lang) {
		
		String sentence=null;
		switch(lang){
		
		case English: sentence="It's not true that ["+this.getNegation()+"]";
		break;
		
		}
		return sentence;

	}



	
	public Constructor getConstructorForFactory() {
		
		Constructor con=null;
		
		try {
			con=Negation.class.getConstructor(Statement.class);
		} catch (NoSuchMethodException | SecurityException e) {
			
			LOG.severe("Negation could not supply constructor for Factory!");

		}
		return con;
	}
}

	