package entities;

import java.lang.reflect.Constructor;
import java.util.logging.ConsoleHandler;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.OneToOne;
import javax.persistence.Table;


import definitions.FactoryCreatable;
import definitions.Language;
import embeddables.Sentence;

@Entity
@Table
public class SentenceStatement extends Statement implements FactoryCreatable{
	
	private static transient final Logger LOG=Logger.getLogger(SentenceStatement.class.getName());
	static{
		
			LOG.setLevel(Level.ALL);
			ConsoleHandler console=new ConsoleHandler();
			console.setLevel(Level.ALL);
	}
	
	private Sentence sentence;
	

	
	@Column
	@OneToOne
	public Sentence getSentence() {
		return sentence;
	}

	public void setSentence(Sentence sentence) {
		this.sentence = sentence;
	}
	public SentenceStatement() {
		super();
		// TODO Auto-generated constructor stub
	}

	public String toString(){
		
		
		return this.sentence.toString();
		
	}
	
	public SentenceStatement(String string, Language language){
		super();
		this.sentence=new Sentence(string, language);
	}

	@Override
	String toString(Language lang) {
		
		return this.sentence.toString();
	}

	@Override
	public Constructor getConstructorForFactory() {
		
		Constructor con=null;
		
		try {
			con= SentenceStatement.class.getConstructor(String.class, Language.class);
		} catch (NoSuchMethodException | SecurityException e) {
			LOG.severe("SentenceStatement could not supply constructor for factory!");
		}
		
		return con;
	}

	

	





}
