package entities;


import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.logging.ConsoleHandler;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.ManyToMany;
import javax.persistence.MappedSuperclass;
import javax.persistence.OneToOne;





@MappedSuperclass
public abstract class Statement extends LogicalObject{
	
	private static final Logger LOG=Logger.getLogger(Statement.class.getName());
	static{
		
			LOG.setLevel(Level.ALL);
			ConsoleHandler console=new ConsoleHandler();
			console.setLevel(Level.ALL);
			
	}
	
	private Statement negation;
	
	private List<Implication> justifications;
	
	
	private List<Implication> results;
	
	
	
	@OneToOne
	public Subject getCreator() {
		return creator;
	}




	
	public void setCreator(Subject creator) {
		this.creator = creator;
	}




	
	





	
	//the dude who was first to state it
	private Subject creator;
	
	
	
	





	@ManyToMany
	@Column
	public List<Implication> getJustifications() {
		return justifications;
	}




	public void setJustifications(List<Implication> justifications) {
		this.justifications = justifications;
	}
	
	






	
	@ManyToMany
	@Column
	public List<Implication> getResults() {
		return results;
	}




	public void setResults(List<Implication>results) {
		this.results = results;
	}
	
	



	  
	
	public Statement(){
		
		//init by Factory
		this.negation=null;
		
		this.believers=new HashSet<Subject>();
		this.justifications=new ArrayList<Implication>();

		
		this.results=new ArrayList<Implication>();
	}
	
	
	
	@ManyToMany	
	public Set<Subject> getBelievers() {
		return believers;
	}
	public void setBelievers(Set<Subject> believers) {
		this.believers = believers;
	}

	
	
	
 
	private Set<Subject> believers;
	
	@Column
	@OneToOne(cascade=CascadeType.ALL)
	public Statement getNegation() {
		return negation;
	}
	

	public void setNegation(Statement negation) {
		this.negation = negation;
	}

	


	
	
	
	
	
	
	

}
