package services;

import java.lang.reflect.InvocationTargetException;
import java.util.List;
import java.util.logging.ConsoleHandler;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.ejb.Stateful;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.PersistenceContextType;
import javax.persistence.TypedQuery;

import definitions.FactoryCreatable;
import definitions.Language;

import entities.Implication;
import entities.LogicalObject;
import entities.SentenceStatement;
import entities.Statement;

@Stateful
public class Factory {
	
	private static final Logger LOG=Logger.getLogger(Factory.class.getName());
	static{
		
			LOG.setLevel(Level.ALL);
			ConsoleHandler console=new ConsoleHandler();
			console.setLevel(Level.ALL);
	}
	
	 // Injected database connection:
    @PersistenceContext(type=PersistenceContextType.EXTENDED)
    private EntityManager em;

	public FactoryCreatable create(Class<? extends FactoryCreatable> type,Object...args){
		// TODO Auto-generated method stub
		return null;
	}
	
	public List<LogicalObject>getAllDB(){
		
		TypedQuery<LogicalObject> query = em.createQuery(
	            "SELECT o FROM LogicalObject o ORDER BY o.id", LogicalObject.class);
	        return query.getResultList();
	    
	
		
		
	}
	
	 public void persist(LogicalObject newObject) {
		 
	 
	        em.persist(newObject);

	 }
	 
	 public LogicalObject createNewObjectToMemory(Class<? extends FactoryCreatable> type,Object...args) {
			
			
			LogicalObject newObject = null;
			try {
				newObject = (LogicalObject) ((FactoryCreatable) type.newInstance()).getConstructorForFactory().newInstance(args);
			} catch (InstantiationException | IllegalAccessException
					| IllegalArgumentException | InvocationTargetException e) {
				
				LOG.severe("Factory could not create newobject from Constructor supplied! because "+e.getMessage());
			}
			return newObject;
		}
	 
	 public LogicalObject createById(long l){
			
			
			return em.find(LogicalObject.class,l);
			
			
		}
	 
	 public LogicalObject createNewObject(Class<? extends FactoryCreatable> type,Object...args){
		 
		 LogicalObject newObject=createNewObjectToMemory(type, args);
		 
		 type.cast(newObject);
		 
		 persist(newObject);
		 
		 return newObject;
	 }
	 
	 
	 
}