package services;
 
import java.io.IOException;
import javax.ejb.EJB;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import definitions.Language;

import entities.LogicalObject;
import entities.SentenceStatement;
 
@WebServlet(name="PaltzefomatServlet", urlPatterns={"/paltzefomat"})
public class PaltzefomatServlet extends HttpServlet {
  private static final long serialVersionUID = 1L;
 
    // Injected DAO EJB:
    @EJB 
    Tester tester;
 
    @Override
    protected void doGet(
        HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
 
        // Display the list of guests:
        request.setAttribute("list",tester.getList());
        
        
        request.setAttribute("prediction",tester.getPrediction());
        request.getRequestDispatcher("/paltzefomat.jsp").forward(request, response);
    }
 
    @Override
    protected void doPost(
        HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
 
        // Handle a new guest:
        String input = request.getParameter("input");
        if (input != null){
        	
        	LogicalObject found=tester.test(input);
        	request.setAttribute("found", found);
        }
 
        // Display the list of guests:
        doGet(request, response);
    }
}